{

(c) GNU General Public License
(c) 1995-99 by raVen

mpeg'z informator

}
{&Use32+}
{$R-}
{}
Unit rMP3Info;
interface
Uses Objects,Strings,rStrings,rObjects,rCommon;
{}
const
 MpegGenres: array[0..147] of PChar =
  ('Blues','Classic Rock','Country','Dance','Disco','Funk','Grunge','Hip-Hop','Jazz','Metal','New Age',
   'Oldies','Other','Pop','R&B','Rap','Reggae','Rock','Techno','Industrial','Alternative','Ska','Death Metal',
   'Pranks','Soundtrack','Euro-Techno','Ambient','Trip-Hop','Vocal','Jazz+Funk','Fusion','Trance',
   'Classical','Instrumental','Shit','House','Game','Sound Clip','Gospel','Noise','Alt. Rock','Bass',
   'Soul','Punk','Space','Meditative','Instrumental Pop','Instrumental Rock','Ethnic','Gothic','Darkwave',
   'Techno-Industrial','Electronic','Pop-Folk','Eurodance','Dream','Southern Rock','Comedy',
   'Cult','Gangsta Rap','Top 40','Christian Rap','Pop/Funk','Jungle','Native American','Cabaret',
   'New Wave','Psychedelic','Rave','Showtunes','Trailer','Lo-Fi','Tribal','Acid Punk','Acid Jazz','Polka',
   'Retro','Musical','Rock & Roll','Hard Rock','Folk','Folk/Rock','National Folk','Swing','Fast-Fusion',
   'Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde','Gothic Rock','Progressive Rock','Psychedelic Rock',
   'Symphonic Rock','Slow Rock','Big Band','Chorus','Easy Listening','Acoustic','Humour','Speech',
   'Chanson','Opera','Chamber Music','Sonata','Symphony','Booty Bass','Primus','Porn Groove','Satire',
   'Slow Jam','Club','Tango','Samba','Folklore','Ballad','Power Ballad','Rhythmic Soul','Freestyle',
   'Duet','Punk Rock','Drum Solo','A Cappella','Euro-House','Dance Hall','Goa','Drum & Bass','Club-House',
   'Hardcore','Terror','Indie','BritPop','Negerpunk','Polsk Punk','Beat','Christian Gangsta Rap','Heavy Metal',
   'Black Metal','Crossover','Contemporary Christian','Christian Rock','Merengue','Salsa','Trash Metal',
   'Anime','JPop','Synthpop');
 cr        : pChar = #13#10#13#10' raVen''s mpegz informator'#13#10#13#10;
 RiffHead  : pChar = 'riff';
 Answers: Array[0..1] of pChar =
  ('Non','Yep');
 Unknown   : pChar = 'Unkn0wn';
 nUnknown  : Word  = $FFFF;
 Layer     : pChar = 'Layer ';
 Mpeg      : pChar = 'Mpeg ';
 MpegTagID : Array[1..3] of Char = 'TAG';
type
{}
  tMpegID = record
    Tag     : Array[1..3]  of Char;
    Title   : Array[1..30] of Char;
    Artist  : Array[1..30] of Char;
    Album   : Array[1..30] of Char;
    Year    : Array[1..4]  of Char;
    Comment : Array[1..30] of Char;
    Genre   : System.Byte;
  end;
  tMpegInfo = Array[0..3] of Byte;
{( tMpeg )}
 pMpeg = ^tMpeg;
 tMpeg = Object(tObject)
  MpegID   : tMpegID;
  MpegInfo : String[32];
  CutRiff  : Boolean;
  constructor init;
  destructor  done; virtual;
  function    Load(FileName: String): Byte;
  function    IsMpeg: Boolean;

  function    GetTitleString: String;
  function    GetArtistString: String;
  function    GetAlbumString: String;
  function    GetYearString: String;
  function    GetCommentString: String;
  function    GetGenreString: String;
  function    GetMpegString: String;
  function    GetLayerString: String;
  function    GetChannelString: String;
  function    GetPlayTimeString: String;
  function    GetBitRateString: String;
  function    GetOriginalString: String;
  function    GetCopyrightString: String;
  function    GetPrivateString: String;
  function    GetErrorProtString: String;

  function    GetOriginal: Boolean;
  function    GetCopyright: Boolean;
  function    GetPrivate: Boolean;
  function    GetErrorProt: Boolean;
  function    GetLayer: Word;
  function    GetSampleRate: Word;
  function    GetBitRate: Word;
  function    GetPlayTimeSeconds: Longint;

priVate
  vbr: Boolean;
  FrameCount: Longint;
  MpegSize  : Longint;
  function    GetMpegVer: Byte;
 end;
{}
implementation
Uses Dos;
{}
function Str2Pas(var What; Len: Word): string;
 var
  x: Word;
  NewSt: Array[0..0] of Char absolute What;
 begin
  Str2Pas[0]:=Char(Len);
  for x:=0 to Len-1 do if NewSt[x]=#0 then Str2Pas[x+1]:=#32 else Str2Pas[x+1]:=NewSt[x];
 end;
{( tMpeg )}
constructor tMpeg.init;
 begin
  inherited init;
  FillChar(MpegID,SizeOf(MpegID),#0);
  MpegID.Genre:=$FF;
  FillChar(MpegInfo,SizeOf(MpegInfo),#0);
  CutRiff:=True;
  Vbr:=False;
  FrameCount:=0;
 end;
{}
destructor  tMpeg.done;
 begin
  inherited done;
 end;
{}
function    tMpeg.Load;
 var
  st: pStream;
  LocalMpegInfo: tMpegInfo;
  x: Byte;
  s: String;
  q: Array[1..4] of Char absolute FrameCount;
  fattr: Word;
  f: File;
 begin
  Load:=1;
  Vbr:=False;
  FrameCount:=0;
  FillChar(MpegID,SizeOf(MpegID),#0);
  MpegID.Genre:=$FF;
  FillChar(MpegInfo,SizeOf(MpegInfo),#0);
  if Not Exist(FileName) then exit;
  Assign(f,FileName);
  GetFAttr(f,fattr);
  SetFAttr(f,Archive);
  st:=New(pBufStream,Init(FileName,stOpen,BlockSize));
  s[0]:=#4;
  st^.Read(s[1],4);
  if UpStr(s)=UpStr(StrPas(RiffHead)) then
   begin
    if CutRiff then
     begin
      CutStream(st^,0,$46);
      st^.Seek(0)
     end
    else
     st^.Seek($46);
   end
  else
   st^.Seek(0);
  MpegSize:=st^.GetSize;
  with st^ do
   begin
    Read(LocalMpegInfo,SizeOf(LocalMpegInfo));
    Seek(GetSize-SizeOf(tMpegID));
    Read(MPegID,SizeOf(MpegID));

    Seek($2B); Read(s[1],1); Seek($A1); Read(s[2],1); s[0]:=#2;
    vbr:=((s=#15#15) or (s[1]=#15));
    if vbr then
     begin
      Seek($2C); Read(q[4],1); Read(q[3],1); Read(q[2],1); Read(q[1],1);
     end;
   end;
  DisposeObj(St);
  SetFAttr(f,fattr);
  for x:=0 to 3 do MpegInfo:=MpegInfo+BinaryB(LocalMpegInfo[x]);
  Load:=0;
 end;
{}
function    tMpeg.GetTitleString;
 var
  s: string;
 begin
  s:=Trim(Str2Pas(MpegID.Title,30),[' ']);
  if (s='') or (MpegID.TAG<>MpegTagID) then GetTitleString:=StrPas(Unknown) else GetTitleString:=s;
 end;
{}
function    tMpeg.GetArtistString;
 var
  s: string;
 begin
  s:=Trim(Str2Pas(MpegID.Artist,30),[' ']);
  if (s='') or (MpegID.TAG<>MpegTagID) then GetArtistString:=StrPas(Unknown) else GetArtistString:=s;
 end;
{}
function    tMpeg.GetAlbumString;
 var
  s: string;
 begin
  s:=Trim(Str2Pas(MpegID.Album,30),[' ']);
  if (s='') or (MpegID.TAG<>MpegTagID) then GetAlbumString:=StrPas(Unknown) else GetAlbumString:=s;
 end;
{}
function    tMpeg.GetYearString;
 var
  s: string;
 begin
  s:=Trim(Str2Pas(MpegID.Year,04),[' ']);
  if (s='') or (MpegID.TAG<>MpegTagID) then GetYearString:=StrPas(Unknown) else GetYearString:=s;
 end;
{}
function    tMpeg.GetCommentString;
 var
  s: string;
 begin
  s:=Trim(Str2Pas(MpegID.Comment,30),[' ']);
  if (s='') or (MpegID.TAG<>MpegTagID) then GetCommentString:=StrPas(Unknown) else GetCommentString:=s;
 end;
{}
function    tMpeg.GetGenreString;
 var
  s: string;
 begin
  if (MpegID.Genre>=0) and (MpegID.Genre<=147) then s:=StrPas(MpegGenres[MpegID.Genre]) else s:='';
  if (s='') or (MpegID.TAG<>MpegTagID) then GetGenreString:=StrPas(Unknown) else GetGenreString:=s;
 end;
{}
function    tMpeg.GetMpegString;
 var
  n: Longint;
 begin
  n:=GetMpegVer;
   case n of
    $10: GetMpegString:=StrPas(Mpeg)+'1.0';
    $20: GetMpegString:=StrPas(Mpeg)+'2.0';
    $25: GetMpegString:=StrPas(Mpeg)+'2.5';
    else GetMpegString:=StrPas(Mpeg)+'?.?';
   end;
 end;
{}
function    tMpeg.GetLayerString;
 var
  n: Longint;
 begin
  n:=ToDec(MpegInfo[14]+MpegInfo[15],2);
  case n of
   3: GetLayerString:=StrPas(Layer)+'1';
   2: GetLayerString:=StrPas(Layer)+'2';
   1: GetLayerString:=StrPas(Layer)+'3';
   else GetLayerString:=StrPas(Unknown);
  end;
 end;
{}
function    tMpeg.GetChannelString;
 var
  n: Longint;
 begin
  n:=ToDec(MpegInfo[25]+MpegInfo[26],2);
  case n of
   0: GetChannelString:='Stereo';
   1: GetChannelString:='Joint Stereo';
   2: GetChannelString:='Dual Channel';
   3: GetChannelString:='Mono :-(';
   else GetChannelString:=StrPas(Unknown);
  end
 end;
{}
function tMpeg.GetPlayTimeString;
 var
  TimeSec: Longint;
 begin
  TimeSec:=GetPlayTimeSeconds;
  GetPlayTimeString:=NToC(TimeSec div 60)+':'+LeadZero(TimeSec mod 60,2);
 end;
{}
function    tMpeg.GetBitRateString: String;
 begin
  if vbr then GetBitRateString:='[VBR] '+NToC(Round((MpegSize/(128*GetPlayTimeSeconds))))
  else GetBitRateString:=NToC(GetBitRate);
 end;
{}
function    tMpeg.GetOriginalString: String;
 begin
  GetOriginalString:=StrPas(Answers[Byte(GetOriginal)]);
 end;
{}
function    tMpeg.GetCopyrightString: String;
 begin
  GetCopyrightString:=StrPas(Answers[Byte(GetCopyright)]);
 end;
{}
function    tMpeg.GetPrivateString: String;
 begin
  GetPrivateString:=StrPas(Answers[Byte(GetPrivate)]);
 end;
{}
function    tMpeg.GetErrorProtString: String;
 begin
  GetErrorProtString:=StrPas(Answers[Byte(GetErrorProt)]);
 end;
{}
function    tMpeg.GetMpegVer;
 var
  n: Longint;
 begin
  GetMpegVer:=0;
  n:=ToDec(MpegInfo[12]+MpegInfo[13],2);
  case n of
   0: GetMpegVer:=$25;
   2: GetMpegVer:=$20;
   3: GetMpegVer:=$10;
   else GetMpegVer:=$FF;
  end;
 end;
{}
function    tMpeg.GetOriginal;
 begin
  GetOriginal:=Boolean(CToN(MpegInfo[30]));
 end;
{}
function    tMpeg.GetCopyright;
 begin
  GetCopyRight:=Boolean(CToN(MpegInfo[29]));
 end;
{}
function    tMpeg.GetPrivate;
 begin
  GetPrivate:=Boolean(CToN(MpegInfo[24]));
 end;
{}
function    tMpeg.GetErrorProt;
 begin
  GetErrorProt:=Boolean(CToN(MpegInfo[16]));
 end;
{}
function    tMpeg.GetSampleRate;
 var
  ver: Byte;
  n: Longint;
 begin
  GetSampleRate:=$FFFF;;
  ver:=GetMpegVer;
  n:=ToDec(MpegInfo[21]+MpegInfo[22],2);
  if ver=$10 then
   case n of
    0: GetSampleRate:=44100;
    1: GetSampleRate:=48000;
    2: GetSampleRate:=32000;
   end;
  if ver=$20 then
   case n of
    0: GetSampleRate:=22050;
    1: GetSampleRate:=24000;
    2: GetSampleRate:=16000;
   end;
  if ver=$25 then
   case n of
    0: GetSampleRate:=11025;
    1: GetSampleRate:=12000;
    2: GetSampleRate:=08000;
   end;
  if (Ver<>$10) and (Ver<>$20) and (Ver<>$25) then GetSampleRate:=$FFFF;
 end;
{}
function    tMpeg.GetLayer;
 var
  n: Longint;
 begin
  n:=ToDec(MpegInfo[14]+MpegInfo[15],2);
  case n of
   3: GetLayer:=1;
   2: GetLayer:=2;
   1: GetLayer:=3;
   else GetLayer:=nUnknown;
  end;
 end;
{}
function    tMpeg.GetBitRate;
 var
  n: Byte;
 begin
  GetBitRate:=$FFFF;
  n:=ToDec(MpegInfo[17]+MpegInfo[18]+MpegInfo[19]+MpegInfo[20],2);
  if GetMpegver=$10 then
   begin
    if GetLayer=1 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=032;
     $2: GetBitRate:=064;
     $3: GetBitRate:=096;
     $4: GetBitRate:=128;
     $5: GetBitRate:=160;
     $6: GetBitRate:=192;
     $7: GetBitRate:=224;
     $8: GetBitRate:=256;
     $9: GetBitRate:=288;
     $a: GetBitRate:=320;
     $b: GetBitRate:=352;
     $c: GetBitRate:=384;
     $d: GetBitRate:=416;
     $e: GetBitRate:=448;
    end;
    if GetLayer=2 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=032;
     $2: GetBitRate:=048;
     $3: GetBitRate:=056;
     $4: GetBitRate:=064;
     $5: GetBitRate:=080;
     $6: GetBitRate:=096;
     $7: GetBitRate:=112;
     $8: GetBitRate:=128;
     $9: GetBitRate:=160;
     $a: GetBitRate:=192;
     $b: GetBitRate:=224;
     $c: GetBitRate:=256;
     $d: GetBitRate:=320;
     $e: GetBitRate:=384;
    end;
    if GetLayer=3 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=032;
     $2: GetBitRate:=040;
     $3: GetBitRate:=048;
     $4: GetBitRate:=056;
     $5: GetBitRate:=064;
     $6: GetBitRate:=080;
     $7: GetBitRate:=096;
     $8: GetBitRate:=112;
     $9: GetBitRate:=128;
     $a: GetBitRate:=160;
     $b: GetBitRate:=192;
     $c: GetBitRate:=224;
     $d: GetBitRate:=256;
     $e: GetBitRate:=320;
    end;
   end;
  if (GetMpegver=$20) or (GetMpegver=$25) then
   begin
    if GetLayer=1 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=032;
     $2: GetBitRate:=048;
     $3: GetBitRate:=056;
     $4: GetBitRate:=064;
     $5: GetBitRate:=080;
     $6: GetBitRate:=096;
     $7: GetBitRate:=112;
     $8: GetBitRate:=128;
     $9: GetBitRate:=144;
     $a: GetBitRate:=160;
     $b: GetBitRate:=176;
     $c: GetBitRate:=192;
     $d: GetBitRate:=224;
     $e: GetBitRate:=256;
    end;
    if GetLayer=2 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=008;
     $2: GetBitRate:=016;
     $3: GetBitRate:=024;
     $4: GetBitRate:=032;
     $5: GetBitRate:=040;
     $6: GetBitRate:=048;
     $7: GetBitRate:=056;
     $8: GetBitRate:=064;
     $9: GetBitRate:=080;
     $a: GetBitRate:=096;
     $b: GetBitRate:=112;
     $c: GetBitRate:=128;
     $d: GetBitRate:=144;
     $e: GetBitRate:=160;
    end;
    if GetLayer=3 then case n of
     $0: GetBitRate:=000;
     $1: GetBitRate:=008;
     $2: GetBitRate:=016;
     $3: GetBitRate:=024;
     $4: GetBitRate:=032;
     $5: GetBitRate:=040;
     $6: GetBitRate:=048;
     $7: GetBitRate:=056;
     $8: GetBitRate:=064;
     $9: GetBitRate:=080;
     $a: GetBitRate:=096;
     $b: GetBitRate:=112;
     $c: GetBitRate:=128;
     $d: GetBitRate:=144;
     $e: GetBitRate:=160;
    end;
   end;
  if (GetMpegVer<>$10) and (GetMpegVer<>$20) and (GetMpegVer<>$25) then GetBitRate:=$FFFF;
 end;
{}
function tMpeg.GetPlayTimeSeconds;
 begin
  if vbr then GetPlayTimeSeconds:=Round(FrameCount/38.35)
  else GetPlayTimeSeconds:=MpegSize div (GetBitRate * 128);
 end;
{}
function    tMpeg.IsMpeg;
 var
  s: string[11];
 begin
  s:=MpegInfo;
  IsMpeg:=ToDec(s,2)=$7FF;
 end;
{}
end.
